#ifndef _APLIC_CH_

#define _APLIC_CH_

// Estructura del array que define una aplicacin
#define cNAME_PROG	1
#define cNAME_APLI	2
#define cNAME_VERS	3
#define cHELP_SYSTEM	4
#define cNAME_LINKER	5


#define M_INFORMATION  aInformation
#define M_SYSTEM       aSystem
#define M_ARRAYS       aArrays
#define M_TASKS        aTasks
#define M_UTILITY      aUtility
#define M_HELP	       aHelp

// Estructura de los menus
#define MNU_INFORMATION 1
#define MNU_SYSTEM	2
#define MNU_ARRAYS	3
#define MNU_TASKS	4
#define MNU_UTILITY	5
#define MNU_HELP	6

#define MNU_LEN 	6


#command   APLICATION <cName> ;
					 ;
	=> function main( cParams );
	     ;LOCAL aMenuAplic := {},;
		    aMenu	:= {},;
		    aAreasAplic := {},;
		    aFldFiles := {},;
		    aInformation := {},;
		    aSystem := {}, ;
		    aArrays := {}, ;
		    aTasks := {},  ;
		    aUtility := {},;
		    aHelp := {},   ;
		    cDbfName := "tdco.DBF";
	     ;Environment( cParams );
	     ;aAplicCfg( cNAME_APLI, <cName> )

#command   APLICATION NO INIT <cName> ;
					 ;
	=> function main( cParams );
         ;LOCAL aMenuAplic := {},;
		    aMenu	:= {},;
		    aAreasAplic := {},;
		    aFldFiles := {},;
		    aInformation := {},;
		    aSystem := {}, ;
		    aArrays := {}, ;
		    aTasks := {},  ;
		    aUtility := {},;
		    aHelp := {},   ;
            cName := <cName>,;
            cDbfName := "tdco.DBF"

#command INIT ENVIRONMENT => ;
          Environment( cParams ) ;;
          aAplicCfg( cNAME_APLI, cName ) ;;
          cName := NIL

#command    VERSION ID <cVersion>  ;
;
	=> aAplicCfg( cNAME_VERS, <cVersion> )


#command    PROGRAMING BY <cNameProg>	   ;
					   ;
	=> aAplicCfg( cNAME_PROG, <cNameProg> )

#command    HELP SYSTEM <cHelpSystem>	;
;
	=> aAplicCfg( cHELP_SYSTEM, <cHelpSystem> )

#command    USAGE LINKER <cNameLinker>	 ;
;
	=> aAplicCfg( cNAME_LINKER, <cNameLinker> )


#command    SCREEN ;
;
	=> PantInicial()

#command   INITIAL MESSAGE [<cMsg>];
;
	=> InitMsg( [<cMsg>] )

#command    QUICK EXIT => SetKey( 301, { || Finalizar() } );;
			  SetKey( 272, { || Finalizar() } )

#command    DEFINE FILE <cName> 				;
;
	=>  cDbfName := <cName>;
	    ;aFldFiles := {}

#command    FIELD <cFld> [TYPE <cType>] [LEN <nLen>] [DECIMALS <nDecimals>];
;
	 => aadd( aFldFiles, { <"cFld">, #<cType>, #<nLen>, #<nDecimals> } )

#command    END FILE;
;
	=> MakeFile( cDbfName, aFldFiles );
	   ;aFldFiles := {};
	   ;cDbfName := "tdco.dbf"

#command DEFINE LOOKUP <cName> CODE <nLenCod> DESCRIPTION <nLenDes>;
;
	=> DEFINE FILE <cName>;
	     ;FIELD Codigo	LEN <nLenCod>;
	     ;FIELD Descripcion LEN <nLenDes>;
	   ;END FILE

#xtranslate INIT FILES ;
 =>	   DBFStatic()
// El comando USAR se encarga de aadir a este array por medio de la clausula
// LABEL.


#translate ADD ITEM ;
		   <cLabel>;
		   [<lAct: ACTIVE>];
		   [<lChe: CHECKED>];
		   [MESSAGE <cMsg>];
		   [EXECUTE <xExec> [<lMenu: SUBMENU>]];
	 INTO <cNomVar>;
=> aadd( <cNomVar>, { NIL, NIL, <cLabel>,;
		      <.lAct.>, <.lChe.>, [<cMsg>],;
		      if( <.lMenu.>, <xExec>, <{xExec}> ) } )

#command SEPARATOR INTO <aMenu> => ADD ITEM "" INTO <aMenu>

#command INHERIT FROM <aName> INTO <aMenu>;
;
=>;
	Inherit( <aName>, <aMenu> )

#command DEL ITEM <nPos> INTO <aMenu> ;
;
	=> aDel( <aMenu>, <nPos> );;
	   aSize( <aMenu>, Len( <aMenu> ) - 1 )

#command DEFINE MENU => aMenuAplic := IHHorizontal()

#command EXECUTE MENU [IN <nRow>, <nCol>];
;
	=>    Exec( { aInformation, aSystem, aArrays,;
		      aTasks, aUtility, aHelp }, [<nRow>], [<nCol>], aMenuAplic )

#command END APLICATION  ;
;
	=>  return NIL


#endif
