/*************************************************************************
   C O M A N D O S     P A R A     U S A R     C O N     C U A W I S E

  (c) Francisco Morero Peyrona
 
**************************************************************************/

#ifndef _CUAWISE

#define _CUAWISE

//---------------------- CARGO DE LOS CUA-GET ----------------------------
#define CUA_CLASS   1      // Nombre de la clase
#define CUA_BLOCK   2      // Bloque de cdigo para Set-Get de la var
#define CUA_DIM     3      // Coordenadas en pantalla
#define CUA_LABEL   4      // Etiqueta del objeto
#define CUA_COLORS  5      // array de colores
#define CUA_FOCUSED 6      // Si tiene el Focus, .t., sino .f.
#define CUA_CARGO   7      // Almacena datos propios de cada objeto
#define CUA_AREA    8      // { Y1,X1,Y2,X2 } Area de Scr ocupada por el objeto
#define CUA_HOTKEY  9      // { nY, nX, cKey, nCod } Posicin, char y codigo Alt
#define CUA_LEN     9      // N de elementos que tiene el array de Cargo de GET


//------------------------- NORMAL GET -----------------------------------

#command @ <nRow>, <nCol> GETCUA <uVar>                                   ;
                         [LABEL <cLabel>]                                 ;
                         [PICTURE <cPic>]                                 ;
                         [WHEN <bWhen>]                                   ;
                         [VALID <bValid>]                                 ;
                         [COLOR <cColor>]                                 ;
                         [SEND <msg>]                                     ;
                                                                          ;
      => SetPos( <nRow>, <nCol> + Len( StrTran( <cLabel>,"&","",1,1 ) ) );;
         AAdd( GetList,                                                   ;
               GetCuaNew( <nRow>, <nCol>, <cLabel>, <cColor>,             ;
               _GET_(<uVar>, <(uVar)>, <cPic>, <{bValid}>, <{bWhen}>) ) ) ;
         [; ATail(GetList):<msg>]



//------------------------- PUSH BUTTON ----------------------------------

#command @ <nRow>, <nCol> BUTTON <cLabel>                                ;
                         [WHEN <bWhen>]                                  ;
                         [EXECUTE <bExec>]                               ;
                         [COLOR <cColor>]                                ;
                                                                         ;
      => AAdd( GetList, PbtNew( <nRow>, <nCol>, <cLabel>, [<{bWhen}>],   ;
                                [<{bExec}>], [<cColor>] ) )



//-------------------------- LIST BOX ------------------------------------

#command @ <nRow>, <nCol> GET <uVar> LISTBOX <aArray>                     ;
                         [LABEL <cLabel>]                                 ;
                         [SIZE <nAlto>, <nAncho>]                         ;
                         [WHEN <bWhen>]                                   ;
                         [VALID <bValid>]                                 ;
                         [BOX <cBox>]                                     ;
                         [COLOR <cColor>]                                 ;
                                                                          ;
      => AAdd( GetList, ListNew( <nRow>, <nCol>, [<nAlto>], [<nAncho>],   ;
                        { | u | If( u == nil, <uVar>, <uVar> := u ) },    ;
                        <"uVar">, <aArray>, [<cLabel>], [<{bWhen}>],      ;
                        [<{bValid}>], [<cBox>], [<cColor>] ) )



//--------------------------- COMBO BOX ----------------------------------

#command @ <nRow>, <nCol> SAY <cLabel> GET <uVar> COMBO <aItems>          ;
                         [PICTURE <cPic>]                                 ;
                         [HIGH <nAlto>]                                   ;
                         [WHEN <bWhen>]                                   ;
                         [VALID <bValid>]                                 ;
                         [BOX <cBox>]                                     ;
                         [COLOR <cColor>]                                 ;
                                                                          ;
      => AAdd( GetList, ComboNew( <nRow>, <nCol>, <cLabel>,               ;
               { |x| If( x == nil, <uVar>, <uVar> := x ) },               ;
               <"uVar">, <aItems>, <cPic>, <nAlto>, <{bWhen}>, <{bValid}>,;
               <cBox>, <cColor> ) )



//--------------------------- CHECK BUTTON -------------------------------

#command @ <nRow>, <nCol> GET <lVar> CHECK <cItem>                       ;
                         [LABEL <cLabel>]                                ;
                         [WHEN <bWhen>]                                  ;
                         [VALID <bValid>]                                ;
                         [COLOR <cColor>]                                ;
                                                                         ;
         => AAdd( GetList, CheckNew( <nRow>, <nCol>,                     ;
            { |x| If( x == nil, <lVar>, <lVar> := x ) },                 ;
            <"lVar">, <cItem>, [<cLabel>],                               ;
            [<{bWhen}>], [<{bValid}>], [<cColor>] ) )



//------------------------- CHECK BUTTON MENU ----------------------------

#command GET <lVar> CHECK <cItem> ADD                                    ;
                                                                         ;
=> CheckAdd( { |x| If( x == nil, <lVar>, <lVar> := x ) }, <cItem>, GetList )



//------------------------- RADIO BUTTON MENU -----------------------------

#command @ <nRow>, <nCol> GET <nVar> RADIO <aArray> [LABEL <cLabel>]      ;
                         [WHEN <bWhen>]                                   ;
                         [VALID <bValid>]                                 ;
                         [COLOR <cColor>]                                 ;
                                                                          ;
      => AAdd( GetList, RadioNew( <nRow>, <nCol>,                         ;
                        { | u | If( u == nil, <nVar>, <nVar> := u ) },    ;
                        <"nVar">, <aArray>, [<cLabel>],           ;
                        [<{bWhen}>], [<{bValid}>], [<cColor>] ) )



//------------------ ACCIONES EN BOTONES Y OTRAS COSAS  -------------------
// Button se escribe con N, no con M, pero comet una falta mecanogrfica,
// as que dejo los dos para aquellos que ya se hayan acostumbrado a la M

#define BTM_OK      __Keyboard( Chr( 23 ) )   // K_CTRL_END
#define BTM_CANCEL  __Keyboard( Chr( 27 ) )   // K_ESC

#define BTN_OK      BTM_OK
#define BTN_CANCEL  BTM_CANCEL

#command CUAREAD => CuaRead( GetList ) ; GetList = {}

#endif
