/*------------------------------------------------------------------------------

   THIS FILE CONTAINS ALL THE NECESSARY MESSAGES FOR THE FOLLOWING OBJ FILES:
  
           - DbOptNtx, Indice, NetMgr, NtxSele, NetMgr

  -------------------------------------------------------------------------

    DbfLanguage() function returns an array with all the necesary
    messages. This array is local to each function that uses it.

  -------------------------------------------------------------------------

    In Config() generates an array named Cfg[], one of its items is
    CONTRY_COD (country code), you can consult/change it easyly anywhere
    in your aplication via the define nCOUNTRY:

       do case
          case nCOUNTRY == 34 ; ? "SPAIN"
          case nCOUNTRY ==  1 ; ? "USA"
          case nCOUNTRY == 33 ; ? "FRANCE"
       endcase

       nCOUNTRY = 34    // new country is Spain

    You can use the code sytem that you want, but we suggest you to use
    the same that is used in DOS.

  -------------------------------------------------------------------------

    Now it is working in a bi-language mode, but if you don't need it,
    you can delete the the parts of the code that you don't need.
    Any case, as you can see, it is easy to have a multi-language
    application with this system.

  -------------------------------------------------------------------------

    If you change it, all that you have to do is to compile again and
    replace it in TDCO library.

  -------------------------------------------------------------------------

    Of course, you can't change the defines used in Dbf_Lang.ch

==============================================================================*/
//============================================================================//

#include "Config.ch"
#include "Dbf_Lang.ch"

function DbfLanguage()

return ( If( nCOUNTRY == 34, Espanol(), English() ) )

//----------------------------------------------------------------------------//

static func Espanol()

   local aMsg := Array( nLEN_DBF_MSG )

   aMsg[ YES_NO         ] = { "S", "No" }
   aMsg[ LBL_BTN_OK     ] = "    &Ok    "
   aMsg[ LBL_BTN_CANCEL ] = " &Cancela "


 //---------------------- DbOptNtx.Obj -------------------------

   aMsg[ NTX_NOFOUND    ] = "No se encontr "
   aMsg[ NTX_ORDER      ] = "Se est ordenando por "
   aMsg[ F_OPEN_ERR     ] = "No se pudo abrir el fichero"

 //----------------------  Indice.Obj  -------------------------

   aMsg[ F_NOT_FOUND    ] = " -> No encontrado"
   aMsg[ F_NOT_HISTORY  ] = " -> No est en el histrico"

 //----------------------  NetMgr.Obj  -------------------------

   aMsg[ ACCESS_FILES   ] = "ACCESO A FICHEROS"
   aMsg[ NUM_TRIES      ] = "Intento N:"

 //---------------------- NtxSele.Obj  -------------------------

   aMsg[ SELECT_MSG     ] = "SELECCIONE"

 //----------------------  RecMgr.Obj  -------------------------

   aMsg[ FK_GOTO        ] = "Ir a"
   aMsg[ FK_FIND        ] = "Busca"
   aMsg[ FK_EDIT        ] = "Edita"
   aMsg[ FK_ADD         ] = "Aade"
   aMsg[ FK_DEL         ] = "Borra"
   aMsg[ YES_NO         ] = { "&S", "&No" }
   aMsg[ DELETE_RECORD  ] = " Seguro que desea;borrar el registro ?"
   aMsg[ FK_BROWSE      ] = "Tabla"
   aMsg[ F_EMPTY        ] = "El fichero est vaco"
   aMsg[ FK_LIST        ] = "Lista"
   aMsg[ FK_FILTER      ] = "Filtr"
   aMsg[ DEFA_FIRST_REC ] = { "Registro actual ","Primer registro " }
   aMsg[ SEARCH_EMPTY   ] = "Est vaca"
   aMsg[ SEARCH_OPTIONS ] = "OPCIONES DE BUSQUEDA"
   aMsg[ SEARCH_COND    ] = "Condicin de bsqueda:"
   aMsg[ SEARCH_FROM    ] = "Comenzar a buscar &desde"
   aMsg[ BTN_SEARCH     ] = " &Buscar "
   aMsg[ BTN_SEARCH_CHG ] = " C&ambiar bsqueda "
   aMsg[ SEARCH_NOFOUND ] = {"No se ha encontrado ningn"," OTRO",";registro que cumpla la condicin;"}
   aMsg[ NO_OPERATION   ] = "Operacin no disponible en este momento."
   aMsg[ GOTO_OPTIONS   ] = { "Anterior  (RePg)",;
                              "Siguiente (AvPg)",;
                              "N de Registro   ",;
                              "Primero          ",;
                              "Ultimo           " }
   aMsg[ GOTO_WND_TITLE ] = "IR A ..."
   aMsg[ GOTO_FIRST_REC ] = "Este es el primer registro"
   aMsg[ GOTO_LAST_REC  ] = "Este es el ltimo registro"
   aMsg[ CANT_DEL_REC   ] = "No se pudo borrar el registro"
   aMsg[ SAVE_CHANGES   ] = "Grabar los datos?"
   aMsg[ NO_ACT_FILTER  ] = "NO hay filtro activo"
   aMsg[ ACT_CAN_FILTER ] = { "&Activar", "&Cancelar" }
   aMsg[ ACTIVE_FILTER  ] = "Filtro activo"
   aMsg[ FLTR_MOD_DEC   ] = { "&Modificar", "&Desactivar", "&Cancelar" }
   aMsg[ FLTR_RELATOR   ] = { "Falso o vaco        ",;
                              "Verdadero o no vaco ",;
                              "Mayor o igual que    ",;
                              "Menor o igual que    ",;
                              "Igual a              ",;
                              "Distinto a           ",;
                              "Que contenga a   ($) " }
   aMsg[ FLTR_WND_TITLE ] = "ACTIVAR FILTRO EN "
   aMsg[ FLTR_BY        ] = " &Filtrar por "
   aMsg[ CHOOSE_RELATOR ] = "&Que sea ..."
   aMsg[ FLTR_CONDITION ] = "C&ondicin "

return aMsg

//----------------------------------------------------------------------------//

static func English()

   local aMsg := Array( nLEN_DBF_MSG )

   aMsg[ YES_NO         ] = { "&Yes", "&No" }
   aMsg[ LBL_BTN_OK     ] = "    &Ok    "
   aMsg[ LBL_BTN_CANCEL ] = "  &Cancel  "

 //---------------------- DbOptNtx.Obj -------------------------

   aMsg[ NTX_NOFOUND    ] = "Not found "
   aMsg[ NTX_ORDER      ] = "Sorting by "
   aMsg[ F_OPEN_ERR     ] = "Error opening file"

 //----------------------  Indice.Obj  -------------------------

   aMsg[ F_NOT_FOUND    ] = " -> Not found"
   aMsg[ F_NOT_HISTORY  ] = " -> Not in history"

 //----------------------  NetMgr.Obj  -------------------------

   aMsg[ ACCESS_FILES   ] = "ACCESS TO FILES"
   aMsg[ NUM_TRIES      ] = "Try number:"

 //---------------------- NtxSele.Obj  -------------------------

   aMsg[ SELECT_MSG     ] = "SELECT"

 //----------------------  RecMgr.Obj  -------------------------

   aMsg[ FK_GOTO        ] = "Go to"
   aMsg[ FK_FIND        ] = "Find"
   aMsg[ FK_EDIT        ] = "Edit"
   aMsg[ FK_ADD         ] = "Add"
   aMsg[ FK_DEL         ] = "Delete"
   aMsg[ DELETE_RECORD  ] = "Do you really want to;delete this record?"
   aMsg[ FK_BROWSE      ] = "Browse"
   aMsg[ F_EMPTY        ] = "File is empty"
   aMsg[ FK_LIST        ] = "List"
   aMsg[ FK_FILTER      ] = "Filtr"
   aMsg[ DEFA_FIRST_REC ] = { "Default Record ", "First Record   " }
   aMsg[ SEARCH_EMPTY   ] = "Is empty"
   aMsg[ SEARCH_OPTIONS ] = "SEARCH OPTIONS"
   aMsg[ SEARCH_COND    ] = "Searching Condition:"
   aMsg[ SEARCH_FROM    ] = "Search From"
   aMsg[ BTN_SEARCH     ] = " &Search "
   aMsg[ BTN_SEARCH_CHG ] = " Ch&ange search "
   aMsg[ SEARCH_NOFOUND ] = {"Not found"," OTHER",";record that match condition;"}
   aMsg[ NO_OPERATION   ] = "Not available operation at this point."
   aMsg[ GOTO_OPTIONS   ] = { "Up        (PgUp) ",;
                              "Down      (PgDn) ",;
                              "Record Number    ",;
                              "First record     ",;
                              "Last  record     " }
   aMsg[ GOTO_WND_TITLE ] = "GO TO..."
   aMsg[ GOTO_FIRST_REC ] = "This is the First record"
   aMsg[ GOTO_LAST_REC  ] = "This is the Last record"
   aMsg[ CANT_DEL_REC   ] = "Unable to delete record"
   aMsg[ SAVE_CHANGES   ] = "Save changes?"
   aMsg[ NO_ACT_FILTER  ] = "There isn't active filter"
   aMsg[ ACT_CAN_FILTER ] = { "&Activate", "&Cancel" }
   aMsg[ ACTIVE_FILTER  ] = "Active Filter"
   aMsg[ FLTR_MOD_DEC   ] = { "&Modify", "&Deactivate", "&Cancel" }
   aMsg[ FLTR_RELATOR   ] = { "False or empty       ",;
                              "True or not empty    ",;
                              "Bigger or equal than ",;
                              "Lower  or equal than ",;
                              "Equal to             ",;
                              "Diferent to          ",;
                              "Matching with    ($) " }
   aMsg[ FLTR_WND_TITLE ] = "ACTIVATE FILTER IN "
   aMsg[ FLTR_BY        ] = "&Filtering by"
   aMsg[ CHOOSE_RELATOR ] = "&That is ..."
   aMsg[ FLTR_CONDITION ] = "C&ondition "

return aMsg

//----------------------------------------------------------------------------//
