/***
*	Erroralf.prg
*	Modificacin del manejador estandar de errores de Clipper 5.01
*	Copyright (c) 1990 Nantucket Corp.  All rights reserved.
*       Copyright (c) 1993 Alfonso Fraguas Bravo. Todos los derechos resevados.
*
*	Compilar con:  /m/n/w
*/

#include "error.ch"
#include "tdco.ch"

#define ERROR_FILE	"Error.log"


// put messages to STDERR
#command ? <list,...>	=>  ?? Chr(13) + Chr(10) ; ?? <list>
#command ?? <list,...>	=>  OutErr(<list>)


// used below
#define NTRIM(n)		( LTrim(Str(n)) )



/***
*	ErrorSys()
*
*	Note:  automatically executes at startup
*/

proc ErrorSys()
	ErrorBlock( {|e| DefError(e)} )
return




/***
*	DefError()
*/
static func DefError(e)
local i, cMessage, aOptions, nChoice, nHandleErr, cGrabar, retorno := "A",;
      cancelar := SETCANCEL()  // Para que no puedan j*dern*s el el fichero de LOG con
			       // ALT+C
      SETCANCEL(.F.)	       // Pos lo inabilitamos, pero guardamos su
			       // valor por si el error es recuperable y
			       // tenemos que regresar a la aplicacin
			       // y dejar el valo rel el capullo del
			       // programador, es decir yo, haya puesto.



	// Si se produce una divisin por cero, como defecto devuelve 0
	if ( e:genCode == EG_ZERODIV )
		return (0)
	end


	// for network open error, set NETERR() and subsystem default
	if ( e:genCode == EG_OPEN .and. e:osCode == 32 .and. e:canDefault )

		NetErr(.t.)
		return (.f.)									// NOTE

	end


	// for lock error during APPEND BLANK, set NETERR() and subsystem default
	if ( e:genCode == EG_APPENDLOCK .and. e:canDefault )

		NetErr(.t.)
		return (.f.)									// NOTE

	end


	// construye el mensaje de error
	cMessage := ErrorMessage(e)

	// contruye el array de opciones
	// aOptions := {"Break", "Quit"}
	aOptions := {"&Terminar"}

	if (e:canRetry)
		AAdd(aOptions, "&Reintentar")
	end

	if (e:canDefault)
		AAdd(aOptions, "&Defecto")
	end



	// put up alert box
	nChoice := 0
	while ( nChoice == 0 )


		if ( Empty(e:osCode) )
			nChoice := Alerta( cMessage, aOptions,,,"SE HA PRODUCIDO UN ERROR" )

		else
			nChoice := Alerta( cMessage + ;
							";(Error del DOS " + NTRIM(e:osCode) + ")", ;
							aOptions,,,"SE HA PRODUCIDO UN ERROR" )
		end

	   if ( nChoice == NIL )
	     exit
	   end

	end


	if ( !Empty(nChoice) )

		// do as instructed
		if ( aOptions[nChoice] == "&Terminar" )
		  retorno := "T"

		elseif ( aOptions[nChoice] == "&Reintentar" )
		  retorno := "R"


		elseif ( aOptions[nChoice] == "&Defecto" )
		  retorno := "D"

		end

	end

	// Graba en el fichero de LOG la fecha,hora y error
	if ( !Empty(e:osCode) )
		cMessage += " (Error del DOS " + NTRIM(e:osCode) + ") "
	end

	IF FILE(ERROR_FILE)
	   nHandleErr := FOPEN(ERROR_FILE,2)
	ELSE
	   nHandleErr := FCREATE(ERROR_FILE)
	ENDIF

	IF nHandleErr != -1

	  FSEEK(nHandleErr,0,2)
	  SET DATE ITALIAN
	  SET CENTURY ON
	  cGrabar := DTOC(DATE())+CHR(13)+CHR(10)
	  SET CENTURY OFF
	  FWRITE(nHandleErr,cGrabar)
	  cGrabar := TIME()+CHR(13)+CHR(10)
	  FWRITE(nHandleErr,TIME()+CHR(13)+CHR(10))
	  cGrabar := cMessage + CHR(13)+CHR(10)
	  FWRITE(nHandleErr,cGrabar)

	  i := 2
	  WHILE ( !Empty(ProcName(i)) )
	    cGrabar := "Mdulo: "+ Trim(ProcName(i)) + " (Lnea: " +;
		      NTRIM(ProcLine(i)) + ")" + CHR(13)+CHR(10)
	    FWRITE(nHandleErr,cGrabar)
	    i++
	  ENDDO
	ENDIF
	// Graba en el fichero de LOG respuesta del operador
	FSEEK(nHandleErr,0,2)
	FWRITE(nHandleErr,"Accin de usuario: " + aOptions[nChoice]+ CHR(13)+CHR(10)+;
	       " " + CHR(13)+CHR(10))

		FCLOSE(nHandleErr)
		DO CASE
		  CASE retorno = "R"
		    SETCANCEL(cancelar)
		    RETURN(.t.)
		  CASE retorno = "D"
		    SETCANCEL(cancelar)
		    RETURN(.f.)
		ENDCASE

	// give up
	ErrorLevel(1)
	SETCANCEL(cancelar)
	SETBLINK(.t.)
	SETCOLOR("W/N")
	SET CURSOR ON
	SET DEVICE TO SCREEN
	SET PRINTER OFF
	CLS
	@ 0,0 SAY "ERROR Irrecuperable de la aplicaccin."
	@ 1,0 SAY "Retorno al Sistema..."
	SETPOS(3,0)
	ResetFont()
	QUIT

return (.f.)




/***
*	ErrorMessage()
*/
static func ErrorMessage(e)
local cMessage


	// start error message
	cMessage := if( e:severity > ES_WARNING, "Error ", "Warning " )


	// add subsystem name if available
	if ( ValType(e:subsystem) == "C" )
		cMessage += e:subsystem()
	else
		cMessage += "???"
	end


	// add subsystem's error code if available
	if ( ValType(e:subCode) == "N" )
		cMessage += ("/" + NTRIM(e:subCode))
	else
		cMessage += "/???"
	end


	// add error description if available
	if ( ValType(e:description) == "C" )
		cMessage += ("  " + e:description)
	end


	// add either filename or operation
	if ( !Empty(e:filename) )
		cMessage += (": " + e:filename)

	elseif ( !Empty(e:operation) )
		cMessage += (": " + e:operation)

	end


return (cMessage)

