/*------------------------------------------------------------------------------
                       GENERAL Visual Clipper FILE MANAGER

  (c) 1993 - Francisco Morero Peyrona

------------------------------------------------------------------------------*/


#include "Inkey.ch"
#include "Directry.ch"
#include "Designer.ch"

MEMVAR aDirTree, cArbol

//----------------------------------------------------------------------------//

function FileManager( cMascara )

   local cPath   := cPATH,;       // path activo
         nTree   := 1,;           // item seleccionado de aTree
         aTreeGra:= {},;          // rbol grfico (devuelto por aDirTree()
         aTreeTxt:= {},;          // path correlativo (devuelto por aDirTree())
         nFic    := 1,;           // item seleccionado en aFic
         aFic    := {},;          // fics del dir selec que cumplen la mascara
         nDrive  := SetDisk()+1,; // disco por defecto
         aDrive  := aDiscos()     // discos disponibles
   local GetList := {}

   local nWnd := WndNew( 3,2,21,74, "General File Manager" )

   SetHelp( 11 )

   cArbol = If( lREDEFINIDO, " " + cARBOL + " ", "  " )
                                                        
   cMascara = PadR( If( cMascara == NIL, "*.*", cMascara ), 12 )
   lLeeTree( aTreeTxt, aTreeGra, cPath )
   lLeeFic( aFic, cPath, cMascara, GetList )


 //-------------- Pantalla ------------------

   @  5, 5 GET nTree LISTBOX aTreeGra LABEL " Directories &tree " SIZE 12,29;
           WHEN  ( GetList[1]:cargo[7,1] := AScan( aTreeTxt, cPath ), .T. );
           VALID ( If( cPath != aTreeTxt[ nTree ],;
             lLeeFic( aFic, cPath:=aTreeTxt[nTree], cMascara, GetList ), .T. ) )

   @  5,39 GET nFic LISTBOX aFic LABEL " &Files " SIZE 12,16;
           WHEN !Empty( aFic )

   if Len( aDrive ) <= 9
      @ 5,60 GET nDrive RADIO aDrive LABEL " Dri&ves ";
             VALID CambiaDrive( nDrive, @cPath, aFic, cMascara,;
                                aTreeTxt, aTreeGra, GetList )
   else
      @ 5,60 GET nDrive LISTBOX aDrive LABEL " Dri&ves " SIZE 9,10;
             VALID CambiaDrive( nDrive, @cPath, aFic, cMascara,;
                                aTreeTxt, aTreeGra, GetList )
   endif

   @ 16,60 SAY "Files filter"   COLOR aClr[ CLR_DLGBOX, 4 ]
   @ 17,60 GET cMascara         COLOR aClr[ CLR_GET ];
           VALID If( Updated(), lLeeFic( aFic, cPath, cMascara, GetList ), .T. )

   @ 19, 5 BUTTON "   &Edit   "   WHEN !Empty( aFic );
           EXEC EditFile( cPath, aFic, nFic )

   @ 19,19 BUTTON "   &Copy   "   WHEN !Empty( aFic );
           EXEC CopyFile( cPath, aFic, nFic, GetList[ 2 ] )

   @ 19,33 BUTTON "  &Rename  "   WHEN !Empty( aFic );
           EXEC RenameFile( cPath, aFic, nFic, GetList[ 2 ] )

   @ 19,47 BUTTON "  &Delete  "   WHEN !Empty( aFic );
           EXEC DeleteFile( cPath, aFic, nFic, GetList )

   @ 19,61 BUTTON "   &Quit   "   EXEC BTN_CANCEL

   ACTIVATE WINDOW nWnd CONTROL GetList KILL

return NIL


//----------------------------------------------------------------------------//
//                  FUNCIONES  DE  VALID  Y  WHEN
//----------------------------------------------------------------------------//

static function CambiaDrive( nDrive, cPath, aFic, cMascara,;
                             aTreeTxt, aTreeGra, GetList )
   local cDir

   if Chr( nDrive + 64 ) != Left( cPath, 1 )
      cDir  = CurDir( Chr( nDrive + 64 ) )
      cPath = Chr( nDrive + 64 ) + ":\" + cDir + If( Empty( cDir ), "", "\" )

      lLeeTree( aTreeTxt, aTreeGra, cPath )
      lLeeFic( aFic, cPath, cMascara, GetList )
   endif

return .T.

//----------------------------------------------------------------------------//

static function lLeeFic( aFic, cPath, cMascara, GetList )

   local aDir, nY := nMAXROW / 2, nCrs := SetCursor( 0 )

   Caja( nY-1, 29, nY+1, 49 )
   @ nY, 33 SAY "Reading files" COLOR aClr[ CLR_BOX, 4 ]
   aDir = LeeDir( cPath, cMascara )
   ASize( aFic, 0 )
   AEval( aDir, { |cItm| AAdd( aFic, cItm ) } )
   Scr( POP )
   AEval( GetList, { |oGet| CuaDisplay( oGet ) } )
   SetCursor( nCrs )

return .T.

//----------------------------------------------------------------------------//

static function lLeeTree( aTreeTxt, aTreeGra, cPath )

   local aTree, i, nY := nMAXROW / 2, nCrs := SetCursor( 0 )

   Caja( nY-1, 25, nY+1, 53 )
   @ nY, 29 SAY "Exploring directories" COLOR aClr[ CLR_BOX, 4 ]

   aTree = aDirTree( Left( cPath, 3 ) )
   ASize( aTreeTxt, 0 )
   ASize( aTreeGra, 0 )

   for i = 1 to Len( aTree[ 1 ] )
       AAdd( aTreeTxt, aTree[ 1, i ] + If( i != 1, "\", "" ) )
       AAdd( aTreeGra, aTree[ 2, i ] )
   next

   Scr( POP )  ;  SetCursor( nCrs )

return .T.

//----------------------------------------------------------------------------//

function aDirTree( cPath, cLine )

   local aDirectories := Directory( If( cPath == nil, cPath := "", cPath ) + ;
                                    "*.*", "D" )
   local nDirs := 0, nLastDir := 0, n

   cLine = If( cLine == NIL, "", cLine )

   if ProcName( 1 ) != "ADIRTREE"
      aDirTree = { { cPath }, { " \ " } }
   endif

   for n = 1 to Len( aDirectories )
       if aDirectories[ n, 5 ] == "D" .and. ;
          aDirectories[ n, 1 ] != "." .and. ;
          aDirectories[ n, 1 ] != ".."
          nDirs++
       endif
   next

   for n = 1 to Len( aDirectories )
       if aDirectories[ n, 5 ] == "D" .and. ;
          aDirectories[ n, 1 ] != "." .and. ;
          aDirectories[ n, 1 ] != ".."
          nLastDir++
          AAdd( aDirTree[ 1 ], cPath + aDirectories[ n, 1 ] )
          AAdd( aDirTree[ 2 ], cLine + ;
                If( nLastDir != nDirs, cArbol, "  " ) + ;
                aDirectories[ n, 1 ] )
          aDirTree( cPath + aDirectories[ n, 1 ] + "\",;
                    cLine + If( nLastDir != nDirs, "  ", "   " ) )
       endif
   next

return aDirTree

//----------------------------------------------------------------------------//

static function aDiscos()

   local acDisk := ADisk()

   AEval( acDisk, { |cItem,i| acDisk[i] := "< " + cItem + ": > " } )

return acDisk


/*------------------------------------------------------------------------------
                   ACCIONES A REALIZAR CON LOS FICHEROS

------------------------------------------------------------------------------*/

static func EditFile( cPath, acFile, nFile )

   local cExt := ""
   local cNomFile := StrTran( Left( acFile[ nFile ], 12 ), " " )

   if ( "." $ cNomFile )
      cExt = SubStr( cNomFile, At( ".", cNomFile )+1 )
   endif

   do case
      case cExt == "DBF"
           DbfEdit( cPath + cNomFile )
      case cExt == "NTX"
           NtxEdit( cPath + cNomFile )
   otherwise
      TxtEditor( cPath + cNomFile )
   endcase

return NIL

//----------------------------------------------------------------------------//

static func CopyFile( cPath, acFile, nFile, oGet )

   local GetList  := {}
   local cNomFile := StrTran( Left( acFile[ nFile ], 12 ), " " )
   local cNewPath := PadR( cPATH + cNomFile, 60 )
   local nWnd     := WndNew( 6,40,12,76, "Copy file  <"+cNomFile+">" )

   @  8,43 GETCUA cNewPath LABEL "Copy &to "    PICT "@S22"
   @ 10,45 BUTTON "    &OK    "  EXEC  BTN_OK
   @ 10,61 BUTTON "  &Cancel  "  EXEC  BTN_CANCEL

   ACTIVATE WINDOW nWnd CONTROL GetList KILL

   if LastKey() != K_ESC
      cNewPath = AllTrim( cNewPath )
      cNewPath += If( SubStr( cNewPath, -1 ) == "\", cNomFile, "" )
      if File( cNewPath ) .and. Alerta( "<"+cNewPath+">;Already exist",;
                                                  {"Overwrite","Cancel"} ) == 2
         return NIL
      endif

      COPY FILE (cPath + cNomFile) TO (cNewPath)
      CuaDisplay( oGet )
   endif

return NIL

//----------------------------------------------------------------------------//

static func RenameFile( cPath, acFile, nFile, oGet )

   local GetList  := {}
   local cNewName := Space( 12 )
   local cNomFile := StrTran( Left( acFile[ nFile ], 12 ), " " )
   local nWnd     := WndNew( 6,45,14,72, "Renaming file" )

   @  8,48 SAY "Old name:"                 COLOR aClr[ CLR_DLGBOX, 4 ]
   @  8,58 SAY cNomFile                    COLOR aClr[ CLR_DLGBOX, 5 ]
 
   @ 10,48 GETCUA cNewName  LABEL "&New name  "
          
   @ 12,48 BUTTON "   &OK   "   EXEC  BTN_OK
   @ 12,59 BUTTON "  &Cancel  " EXEC  BTN_CANCEL

   ACTIVATE WINDOW nWnd CONTROL GetList KILL

   if LastKey() != K_ESC
      if FRename( cPath + cNomFile, cNewName ) == 0
         cNomFile = cNewName
         CuaDisplay( oGet )
      else
         Alerta( "<" + cNomFile + ">;Can't rename file" )
      endif
   endif

return NIL

//----------------------------------------------------------------------------//

static func DeleteFile( cPath, acFile, nFile, GetList )

   local cNomFile := StrTran( Left( acFile[ nFile ], 12 ), " " )

   if Alerta( "<"+cNomFile+">; Delete file ?", {"Yes","No"} ) == 1
      if FErase( cPath + cNomFile ) == 0
         ADel( acFile, nFile )  ;  ASize( acFile, Len( acFile ) - 1 )
         AEval( GetList, { |oGet| CuaDisplay( oGet ) } )
      else
         Alerta( "<" + cNomFile + ">;Can't delete file" )
      endif
   endif

return NIL

//----------------------------------------------------------------------------//
