/*------------------------------------------------------------------------------

   ESPAOL                                    ENGLISH

   Esta funcin manda el listado a            This function sends the list
   una salida estndar (fichero o             to a standar output (file or
   impresora).                                printer).
   Invoked by Listado()                       Called by Listado()
   Puedes cambiar SOLO los mensajes           You can change ONLY the messages
   y volverlo a meter en TDCO.LIB             and include it in TDCO.LIB again.
   Como no dispones de todos los              As you have not all code rela_
   fuentes relacionados con este              tioned with this module, if you
   mdulo, si cambias algo del cdigo         change any code, it could produ_
   pueden producirse comportamientos          ces a malfunction.
   anmalos.


   (c) Francisco Morero Peyrona - 1993
   (c) Alfonso Fraguas Bravo    - 1993

------------------------------------------------------------------------------*/

#include "tdco.ch"
#include "DbStruct.ch"
#include "Inkey.ch"

#define nCOD_USA 1

function ListPrn( aInfPrn, aCabecera, aStruct, nFldOrdena,;
			 acCheckFld, xDesde, xHasta, lTotales )

    local nType   := Set( _SET_TYPEAHEAD, 1 ),;
	  nPosFld := FieldPos( aStruct[ nFldOrdena ][ DBS_NAME ] ),;
	  aCabeza := {},;   // { cNomFld, nLenFld }
	  anFld   := {},;   // Pos ordinal en la dbf de los campos marcados ""
	  aTotal  := {},;   // Contiene el total si fld es N, sino el n de regs
	  nPag	  := 1,;    // n de pag actual
	  nAncho  := 0,;    // Ancho del listado
	  lSeguir := .T.,;
	  cNomFld := "",;
	  nX, nY,;	    // Coordenadas para mostrar msg
	  i, xAux


  //--------- Ventana de estado de la impresin ----------------

    nY = nMAXROW / 2 - 3
    nX = nMAXCOL / 2 - 15
    Set( _SET_DEVICE, "SCREEN" )
       Caja( nY, nX, nY+6, nX+32, If( nCOUNTRY == nCOD_USA, "PRINTING", "IMPRIMIENDO" ), aClr[ CLR_AVISO ] )
       @ nY+2, nX+3 SAY If( nCOUNTRY == nCOD_USA, "Sorting data, wait", "Ordenando los datos, espere" ) COLOR aClr[ CLR_AVISO, 5 ]
       @ nY+5, nX+3 SAY "<ESC> " + If( nCOUNTRY == nCOD_USA, "Cancel printing", "Cancela la impresin" )  COLOR aClr[ CLR_AVISO, 5 ]
    Set( _SET_DEVICE, "PRINTER" )


  /*--------------------------------------------------------------------/
  /  Creamos anFld  -> array con los campos seleccionados		/
  /	     aTotal -> array que almacenar los totales para cada campo /
  /	     aCabeza-> array con el nombre del campo y su longitud,	/
  /		       para los campos N hay que aadir las "," de miles/
  /--------------------------------------------------------------------*/

    FOR i = 1 TO Len( acCheckFld )
	IF SubStr( acCheckFld[ i ], 2, 1 ) == ""
	   cNomFld = AllTrim( SubStr( acCheckFld[ i ], 4 ) )
	   xAux    = AScan( aStruct, { |aItem| aItem[ DBS_NAME ] == cNomFld } )

	   AAdd( anFld, FieldPos( cNomFld ) )
	   AAdd( aTotal, { aStruct[xAux][DBS_TYPE], 0 } )
	   AAdd( aCabeza, { aStruct[xAux][DBS_NAME],;
	    If( aStruct[xAux][DBS_TYPE] != "N", aStruct[xAux][DBS_LEN],;
	    aStruct[xAux][DBS_LEN] + Int( (aStruct[xAux][DBS_LEN]-1) / 3 ) ) } )
	ENDIF
    NEXT

    AEval( aCabeza, { |aItem| nAncho += aItem[2] + 1 } )
    IF nAncho > 80
       PrnCod( PRN_COMPRES_ON )
    ENDIF

    if ValType( xDesde ) == "D"
       INDEX ON DtoS( &(aStruct[ nFldOrdena ][ DBS_NAME ]) ) TO TEMPORAL
       DbSeek( DtoS( xDesde ), .t. )
    else
       INDEX ON &(aStruct[ nFldOrdena ][ DBS_NAME ]) TO TEMPORAL
       DbSeek( xDesde, .t. )
    end if


  //--------------- Comienza la impresion --------------------

    SetPrc( 0, 0 )

    FOR i = 1 TO aInfPrn[ PRN_MGR_SUP ] 	   // Margen superior
	@ PRow() + 1, 0 SAY ""
    NEXT

    IF aCabecera != NIL
       FOR i = 1 TO Len( aCabecera )
	   @ PRow()+1, 0 SAY aCabecera[ i ]
       NEXT
       @ PRow()+1, 0 SAY ""
    ENDIF

    ImprimeCabeza( aCabeza )

    DO WHILE ( FieldGet( nPosFld ) >= xDesde .and.;
	       FieldGet( nPosFld ) <= xHasta .and.;
	       !Eof();
	     )

       IF !Deleted()
	  @ PRow()+1, 0 SAY ""                       // cambio de linea

	  FOR i = 1 TO Len( anFld )
	      StatusMsg( nY+2, nX+3, nPag )
	      xAux := FieldGet( anFld[ i ] )
	      ImprimeValor( xAux, i, aCabeza )
	      IF ValType( xAux ) == "N"
		 aTotal[ i ][ 2 ] += xAux
	      ENDIF
	  NEXT
	  IF !FinDePag( aInfPrn, aCabeza, @nPag, aTotal, lTotales, nAncho )
	     lSeguir := .F.  ;	EXIT
	  ENDIF
       ENDIF

       DbSkip( 1 )

    ENDDO

    IF lSeguir
       IF lTotales
	  IF PRow() + aInfPrn[ PRN_MGR_INF ] + 2  >=  aInfPrn[ PRN_LIN ]
	     EJECT
	  ENDIF
	  ImprimeTotales( aTotal, aCabeza, .F., nAncho )
       ENDIF
       NumerarPg( aInfPrn, @nPag, nAncho )
    ENDIF

    PrnCod( PRN_COMPRES_OFF )
    EJECT
    Scr( POP )
    Set( _SET_TYPEAHEAD, nType )

return NIL


/******************************************************************************
			FUNCIONES ADICIONALES

******************************************************************************/

static function ImprimeValor( xAux, i, aCabeza )

   do case
   case ValType( xAux ) == "C" .or. ValType( xAux ) == "D"
      @ PRow(), PCol()+1 SAY xAux

   case ValType( xAux ) == "N"
      @ PRow(), PCol()+1 SAY xAux;
	PICT Right( Replicate( ",999", 8 ), aCabeza[i][2] )

   case ValType( xAux ) == "L"
      @ PRow(), PCol()+1 SAY If( xAux, "V", "F" )
   endcase

return NIL

//----------------------------------------------------------------------------//

static function FinDePag( aInfPrn, aCabeza, nPag, aTotal, lTotales, nAncho )

   local nOp:= 1, i

 //--------------  Se ha pulsado ESC ? -----------------
   IF Inkey() == K_ESC
      IF Alerta( If( nCOUNTRY == nCOD_USA, "Printer halted", "Impresin detenida" ), ;
                 If( nCOUNTRY == nCOD_USA, {"C&ontinue","Cancel"}, {"Continuar","Abandonar"} ) )!= 1
	 return .F.
      ENDIF
   ENDIF


 //--------------  Es fin de pg ? ----------------------
   IF ( PRow() + aInfPrn[ PRN_MGR_INF ]  >=  aInfPrn[ PRN_LIN ] )
      IF lTotales
	 ImprimeTotales( aTotal, aCabeza, ,nAncho )
      ENDIF

      NumerarPg( aInfPrn, @nPag, nAncho )
      EJECT

      IF aInfPrn[ PRN_PAUSA ] .and. aInfPrn[ PRN_DEVICE ] == "PRN"
         DO WHILE (nOp := Alerta( If( nCOUNTRY == nCOD_USA, "Change page","Cambie de pgina" ),;
                                  If( nCOUNTRY == nCOD_USA, {"C&ontinue","Cancel"}, {"Continuar","Abandonar"} ) )) == 1 .and. !IsPrinter()
	 ENDDO
      ENDIF

      IF nOp == 1
	 FOR i = 1 TO aInfPrn[ PRN_MGR_SUP ]		// Margen superior
	     @ PRow() + 1, 0 SAY ""
	 NEXT
	 ImprimeCabeza( aCabeza )
      ENDIF

   ENDIF

return (nOp == 1)

//----------------------------------------------------------------------------//

static function ImprimeCabeza( aCabeza )

   local nAncho

   @PRow()+1, 0 SAY ""
   AEval( aCabeza, { |aIt| DevOut( " " + PadR( Left( aIt[1],aIt[2] ), aIt[2] ) ) } )
   nAncho = PCol()
   @ PRow()+1, 0 SAY Replicate( "-", nAncho )
   @ PRow()+1, 0 SAY ""

return NIL

//----------------------------------------------------------------------------//

static function NumerarPg( aInfPrn, nPag, nAncho )

   IF aInfPrn[ PRN_NUMERAR ]
      @ aInfPrn[ PRN_LIN ]-1,0 SAY;
	PadC( "- " + LTrim( Str( nPag ) ) + " -", nAncho )
   ELSE
      @ PRow() + 1, 0 SAY ""           // poner el cabezal en la lin siguiente
   ENDIF

   nPag++

return NIL

//----------------------------------------------------------------------------//

static function ImprimeTotales( aTotal, aCabeza, lSubTotal, nAncho )

   local i, cPict

   lSubTotal = If( lSubTotal == NIL, .T., lSubTotal )

   @ PRow()+1, 0 SAY "--- " + If( lSubTotal, "Sub", "" ) + "Totales " +;
		     Replicate( "-", nAncho - If( lSubTotal, 15, 12 ) )
   @ PRow()+1, 0 SAY ""

   FOR i = 1 TO Len( aCabeza )
       IF aTotal[i][1] == "N"
	  cPict = Right( Replicate( ",999", 8 ), aCabeza[i][2] )
	  @ PRow(), PCol()+1 SAY aTotal[i][2] PICT cPict
       ELSE
	  @ PRow(), PCol()+1 SAY Space( aCabeza[i][2] )
       ENDIF
   NEXT

return NIL

//----------------------------------------------------------------------------//

static function StatusMsg( nY, nX, nPag )

   Set( _SET_DEVICE, "SCREEN" )

   @ nY, nX    SAY "Lnea: "  + PadR( LTrim( Str( PRow() ) ), 10 );
	       COLOR aClr[ CLR_AVISO, 5 ]

   @ nY, nX+17 SAY "Pgina: " + PadR( LTrim( Str( nPag ) ), 5 );
	       COLOR aClr[ CLR_AVISO, 5 ]

   Set( _SET_DEVICE, "PRINTER" )

return NIL

//----------------------------------------------------------------------------//

static function IsNumeric( cCadena )

   local n := 1, nLen := 0

   cCadena := AllTrim( cCadena )
   nLen := Len( cCadena )

   for n = 1 to nLen
     if !IsDigit( SubStr( cCadena, n, 1 ) )
	return .f.
     end if
   next n

return .t.

//----------------------------------------------------------------------------//
