/*------------------------------------------------------------------------------
                SHOWS A STRING IN A WINDOW WITH SCROLLBARS

   (c) Francisco Morero Peyrona - 1993
       Alfonso Fraguas Bravo    - 1993

------------------------------------------------------------------------------*/

#include "Colores.ch"
#include "ScrAttr.ch"
#include "Config.ch"
#include "inkey.ch"
#include "Window.ch"

MEMVAR aClr, nLines, nWide, nWndP

func main()

   Config()
   MemoShow( MemoRead( "windows.prg" ) )

retur NIL


function MemoShow( cStr, nAncho, nArr, nIzq, nAbj, nDch, cTitulo )

    local nCrs   := SetCursor( 0 )
    local cColor := SetColor( aClr[ CLR_AVISO, 5 ] )
    local nWnd

    private nLines, nWide, nWndP

    nLines  = MlCount( cStr, nWide )
    nWide   = If( nAncho  == NIL,          80, nAncho )
    nArr    = If( nArr    == NIL,           3, nArr )
    nIzq    = If( nIzq    == NIL,           7, nIzq )
    nAbj    = If( nAbj    == NIL, nMAXROW - 3, nAbj )
    nDch    = If( nDch    == NIL, nMAXCOL - 7, nDch )
    cTitulo = If( cTitulo == NIL,     "VISOR", cTitulo )

    @ nArr, nIzq, nAbj, nDch                                             ;
      CREATE WINDOW nWnd                                                 ;
      TITLE  cTitulo                                                     ;
      CONTROL cStr                                                       ;
      READER { |nWnd, cStr| EditaMemo(nWnd, cStr) }                      ;
      COLOR  aClr[ CLR_AVISO ]                                           ;
      FIX                                                                ;
      ON UP    CLICK { || __Keyboard( Chr( K_UP    ) ) }                 ;
      ON DOWN  CLICK { || __Keyboard( Chr( K_DOWN  ) ) }                 ;
      ON LEFT  CLICK { || __Keyboard( Replicate( Chr( K_LEFT  ), 4 ) ) } ;
      ON RIGHT CLICK { || __Keyboard( Replicate( Chr( K_RIGHT ), 4 ) ) }

    nWndP = nWnd
    ACTIVATE WINDOW nWnd KILL

    SetColor( cColor )
    SetCursor( nCrs )

return NIL

//----------------------------------------------------------------------------//

static func EditaMemo( nWnd, cStr )

   local aWndInfo

   INFO WINDOW nWnd TO aWndInfo

   MemoEdit( cStr, ;
             aWndInfo[ nWND_Y1 ] +1, ;
             aWndInfo[ nWND_X1 ] +1, ;
             aWndInfo[ nWND_Y2 ] -1, ;
             aWndInfo[ nWND_X2 ] -2, ;
             .F., "ShowScroll", nWide )

return NIL

//----------------------------------------------------------------------------//

function ShowScroll( nModo, nLin, nCol )

   if nModo == 0
      nLin = Min( nLin, nLines )
      nCol = Min( nCol, nWide-1 )
      WINDOW nWndP BARSCROLL VERTICAL   nLin OF nLines
      WINDOW nWndP BARSCROLL HORIZONTAL nCol OF nWide
   endif

return NIL
