/*------------------------------------------------------------------------------

   ESPAOL                                     ENGLISH

   Este fichero contiene la funcin            This file contains the function
   a la que se llama desde RecMgr()            that is invoked from RecMgr()
   para hacer el Browse de la Dbf.             to make a Dbf Browse.
   Puedes cambiarlo y volverlo a               You can change it and include
   poner en TDCO.LIB                           again in TDCO.LIB


             Tabla( [lModify], [nTop, nLeft, nBottom, nRight] )

                 View, change, delete, -> NO append allowed

------------------------------------------------------------------------------*/

#include "Inkey.ch"
#include "tdco.ch"
#include "dbstruct.ch"

#define nCOD_USA  1                                 // country code for the USA


function Tabla( lModify, nTop, nLeft, nBottom, nRight )

   local nCrs := SetCursor( 0 )
   local oB, n, oCol, aOldFks, wndBrowse

   if LastRec() == 0
      Alerta( Alias() + if( nCOUNTRY == nCOD_USA, " is empty", " est vaca" ) )
      return NIL
   endif

   aOldFks := ShowFKs( { ,"","","","","", ;
                         if( nCOUNTRY == nCOD_USA, "Order", "Orden" ), ;
                         "","","" } )

   DEFAULT lModify := .T.,         ;
           nTop    := 2,           ;
           nLeft   := 1,           ;
           nBottom := nMAXROW - 2, ;
           nRight  := nMAXCOL - 3

   // create a TBrowse object for a database

   oB := TBrowseDB( nTop + 1, nLeft + 1, nBottom - 2, nRight - 3 )
   oB:headSep   = ""
   oB:colorSpec = aClr[ CLR_BROWSE, 2 ]
   oB:skipBlock = { |x| Skipped( x ) }

   FOR n = 1 TO FCount()
       oCol = TBColumnNew( FieldName(n), FieldBlock( FieldName(n) ) )
       oCol:footSep = ""
       oB:addColumn( oCol )
   NEXT

   @ nTop, nLeft, nBottom, nRight CREATE WINDOW wndBrowse     ;
     TITLE If( nCOUNTRY == nCOD_USA, "Browsing", "Hojeando" )+" <"+Alias()+">" ;
     CONTROL oB  READER { |nWnd, oB| _BrowseDbf( nWnd, oB, lModify ) }

   @ nBottom-1, nLeft+3 SAY If(nCOUNTRY == nCOD_USA,"Record","Ficha") ;
                            COLOR aClr[ CLR_DLGBOX, 4 ]

   ACTIVATE WINDOW wndBrowse KILL

   ShowFks( aOldFks )
   SetCursor( nCrs )

return NIL

//----------------------------------------------------------------------------//

static func _BrowseDbf( nWnd, oB, lModify )

   local lMore   := .T.
   local nOldNTX := IndexOrd()
   local bOldF7  := SetKey( K_F7, NIL )
   local nKey

   RtnCursor( .F. )
   IF ( Eof() )
      GO TOP
   ENDIF

   DO WHILE (lMore)
      DO WHILE ( !oB:stabilize() ) ; ENDDO
      StatLine( oB )

      WINDOW nWnd BARSCROLL VERTICAL   RecNo()      OF LastRec()
      WINDOW nWnd BARSCROLL HORIZONTAL oB:ColPos()  OF oB:ColCount()

      RtnCursor( .T. )
      nKey = Pausa( 0 )
      RtnCursor( .F. )

      DO CASE
	 CASE nKey == K_DOWN	   ;  oB:down()
	 CASE nKey == K_UP	   ;  oB:up()
	 CASE nKey == K_PGDN	   ;  oB:pageDown()
	 CASE nKey == K_PGUP	   ;  oB:pageUp()
	 CASE nKey == K_CTRL_PGUP  ;  oB:goTop()
	 CASE nKey == K_CTRL_PGDN  ;  oB:goBottom()
	 CASE nKey == K_RIGHT	   ;  oB:right()
	 CASE nKey == K_LEFT	   ;  oB:left()
	 CASE nKey == K_HOME	   ;  oB:home()
	 CASE nKey == K_END	   ;  oB:end()
	 CASE nKey == K_CTRL_LEFT  ;  oB:panLeft()
	 CASE nKey == K_CTRL_RIGHT ;  oB:panRight()
	 CASE nKey == K_CTRL_HOME  ;  oB:panHome()
	 CASE nKey == K_CTRL_END   ;  oB:panEnd()
	 CASE nKey == K_ESC	   ;  lMore = .f.
	 CASE nKey == K_F7
              NTXSele()
              if LastKey() != K_ESC
                 RtnCursor( .F. )
                 oB:RefreshAll()
                 RtnCursor( .T. )
              end if

	 /*
	 CASE nKey == K_DEL
	   if lModify
	      if ( !Deleted() )
		 if ( Alerta( "Seguro que desea borrar este registro?", {"S","No"} ) == 1)
		   BorraRec()
		 end if
	      else
		 Alerta( "El registro ya est borrado" )
	      end
	   end if
	 */

	 CASE nKey == K_RETURN
	      if lModify
		 nKey = DoGet( oB )
	      endif
      ENDCASE
   ENDDO

   DbSetOrder( nOldNTX )
   SetKey( K_F7, bOldF7 )

return NIL


/***
*	DoGet()
*	Edit the current field
*/

static func DoGet( oB )

   local lExitSave
   local oCol, oGet, nKey, cExpr, xEval
   local lFresh, nCursSave, mGetVar
   local lRtnProc:= RtnSetProc( .F. )
   local aRtnArea

   // make sure the display is correct
   oB:hitTop = .f.
   Statline( oB )
   do while ( !oB:stabilize() ) ; enddo

   // save state
   lExitSave = Set( _SET_EXIT, .t. )
   nCursSave = SetCursor( If( ReadInsert(), 2, 1 ) )

   // get the controlling index key
   cExpr = IndexKey( 0 )
   if ( !Empty(cExpr) )
      xEval = &cExpr
   end

   // get column object from browse
   oCol = oB:getColumn(oB:colPos)

   // use temp for safety
   mGetVar = Eval(oCol:block)

   // create a corresponding GET with ambiguous set/get block
   aRtnArea = RtnDefArea( Row(), Col(), Row(), Col()+oB:colWidth( oB:colPos ) )
   oGet = GetNew( Row(), Col(),                                              ;
			      {|x| if(PCount() == 0, mGetVar, mGetVar := x)},;
			      "mGetVar",, oB:colorSpec)
   // refresh flag
   lFresh = .f.

   // read it
   if ( CuaRead( { oGet } ) )
      // replace with new data
      Eval(oCol:block, mGetVar)

      // test for change in index order
      if ( !Empty(cExpr) )
	 if ( xEval != &cExpr )
	    lFresh = .t.
	 end
      end
   end

   if ( lFresh )
      FreshOrder(oB)		    // record in new indexed order
      nKey = 0			    // no other action
   else
      // refresh the current row only
      oB:refreshCurrent()
      // certain keys move cursor after edit if no refresh
      nKey = ExitKey()
   end

   // restore state
   Set( _SET_EXIT, lExitSave )
   SetCursor( nCursSave )
   RtnSetProc( lRtnProc )
   RtnDefArea( aRtnArea )

return (nKey)


/***
*	ExitKey()
*	Determine the follow-up action after editing a field
*/

static function ExitKey()

local nKey := LastKey()

   if ( nKey == K_PGDN )
      nKey = K_DOWN
   elseif ( nKey == K_PGUP )
      nKey = K_UP
   elseif ( nKey == K_RETURN .or. (nKey >= 32 .and. nKey <= 255) )
      nKey = K_RIGHT		     // return key or type out..move right
   elseif ( nKey != K_UP .and. nKey != K_DOWN )
      nKey = 0			     // no other action
   endif

return (nKey)


/***
*	FreshOrder()
*	Refresh respecting any change in index order
*/

static func FreshOrder(oB)

local nRec := Recno()


   RtnCursor( .F. )
   oB:refreshAll()
   RtnCursor( .T. )

   // stabilize to see if TBrowse moves the record pointer
   while ( !oB:stabilize() ) ; end

   IF ( nRec != LastRec() + 1 )   // record pointer may move if bof is on screen
      DO WHILE ( Recno() != nRec )
	 // falls through unless record is closer to bof than before
	 oB:up()
	 while ( !oB:stabilize() ) ; end
      ENDDO
   ENDIF

return (NIL)


/***
*	Statline()
*	display status at coordinates relative to TBrowse object
*/

static func Statline( oB )

   local nTop    := oB:nBottom + 1
   local nLeft   := oB:nLeft   + 9
   local cChkON  := If( lREDEFINIDO, cCUA_CHECK_ON , " [X] " )
   local cChkOFF := If( lREDEFINIDO, cCUA_CHECK_OFF, " [ ] " )

   // normal record..display Recno()/LastRec() and Deleted()
   @ nTop, nLeft      SAY Pad( Ltrim(Str(Recno())) + "/" +;
                               Ltrim(Str(LastRec())), 16 );
                      COLOR aClr[ CLR_DLGBOX, 4 ]
   @ nTop, nLeft + 31 SAY If( Deleted(), cChkON, cChkOFF ) + ;
                      If( nCOUNTRY == nCOD_USA, "Deleted", "Borrado" );
                      COLOR aClr[ CLR_DLGBOX,4 ]
   @ nTop, nLeft + 52 SAY If( oB:hitTop, cChkON, cChkOFF ) + "B.O.F.";
                      COLOR aClr[ CLR_DLGBOX, 4 ]

return (NIL)


/***
*	Skipped(n)
*	Skip thru database and return the actual number of records skipped
*/

static function Skipped( nRequest )

local nCount := 0

   if ( nRequest == 0 )
      skip 0
   elseif ( nRequest > 0 .and. Recno() != LastRec() + 1 )
      // forward
      do while ( nCount < nRequest )
	 skip 1
	 if ( Eof() )
	    // back to last actual record
	    skip -1
	    exit
	 endif
	 nCount++
      enddo

   elseif ( nRequest < 0 )
      // backward
      do while ( nCount > nRequest )
	 skip -1
	 if ( Bof() )
	    exit
	 end
	 nCount--
      enddo
   endif

return (nCount)
