#ifndef _WINDOW

   #define _WINDOW

 //------ Defincin de la ventana

   #define nWND_Y1           1          // Coordenadas
   #define nWND_X1           2
   #define nWND_Y2           3
   #define nWND_X2           4
   #define cWND_TIT          5          // Ttulo
   #define cWND_TIPO         6          // Tipo de caja
   #define aWND_CLR          7          // Colores
   #define aWND_CTRL         8          // Control (GetList, TBrowse ...)
   #define bWND_READER       9          // Reader para el Control
   #define nWND_SHADOW      10          // Sombra
   #define cWND_IMAGE       11          // Imagen de la ventana
   #define cWND_SCR         12          // Fondo
   #define nWND_STAT        13          // Estado
   #define lWND_FIX         14          // No se puede mover por pantalla
   #define bWND_ONCLOSE     15          // Accin para antes de cerrar la Wnd
   #define bWND_UPCLICK     16          // Accin para Click en VertScrollBar
   #define bWND_DNCLICK     17          // Accin para Click en VertScrollBar
   #define bWND_LFCLICK     18          // Accin para Click en HorzScrollBar
   #define bWND_RTCLICK     19          // Accin para Click en HorzScrollBar
   #define nWND_CTRL_CLASS  20          // Tipo de control contenido en la Wnd
   #define lWND_MOUSE_FREE  21          // Ratn por toda la pantalla o no
   #define aWND_VSCROL_POS  22          // Uso interno
   #define aWND_HSCROL_POS  23          // Uso interno
   #define nWND_LEN         23


   //-------- Identificadores barras scroll -----------------

   #define nWND_H_SCROLL   1
   #define nWND_V_SCROLL   2
 

   //-------- Tipo de controles de la ventana ---------------

   #define nCTRL_EMPTY     0
   #define nCTRL_DLGBOX    1
   #define nCTRL_DBFMGR    2
   #define nCTRL_TBROWSE   3


   //-------- Tareas a realizar con la ventana --------------

   #define nWND_TASK_ACTIVATE  1
   #define nWND_TASK_CLOSE     2
   #define nWND_TASK_KILL      3
   #define nWND_TASK_MOVE      4
   #define nWND_TASK_INFO      5
   #define nWND_TASK_SAY       6
   #define nWND_TASK_EVENT     7
   #define nWND_TASK_SHOW      8
   #define nWND_TASK_V_BAR     9
   #define nWND_TASK_H_BAR    10


   //-------- Posibles estados de la ventana --------------

   #define nWND_STAT_CREATED   1        // Creada
   #define nWND_STAT_SHOWED    2        // Pintada
   #define nWND_STAT_CLOSED    3        // Esta cerrada
   #define nWND_STAT_ACTIVE    4        // Est funcionando
   #define nWND_STAT_BTNCLOSE  5        // Se ha pulsado botn de cierre


   //-------- Comandos
   #command @ <y1>, <x1>, <y2>, <x2> CREATE WINDOW <cNameWnd>                ;
                                    [TITLE <cTitle>]                         ;
                                    [COLOR <aClr>]                           ;
                                    [CONTROL <aCtrl>]                        ;
                                    [READER <bReader>]                       ;
                                    [<lDbfMgr:AS DBFMGR>]                    ;
                                    [SHADOW <nShadow>]                       ;
                                    [BOX <cType>]                            ;
                                    [<lfix:FIX>]                             ;
                                    [ON CLOSE <bOnClose>]                    ;
                                    [ON UP CLICK <bUpClick>]                 ;
                                    [ON DOWN CLICK <bDnClick>]               ;
                                    [ON LEFT CLICK <bLfClick>]               ;
                                    [ON RIGHT CLICK <bRtClick>]              ;
                                    [<lMFree:FREE MOUSE>]                    ;
                                                                             ;
      => <cNameWnd> := WndNew( <y1>, <x1>, <y2>, <x2>,                       ;
                               <cTitle>,                                     ;
                               <aClr>,                                       ;
                               <aCtrl>,                                      ;
                               <nShadow>,                                    ;
                               <cType>,                                      ;
                               <.lfix.>,                                     ;
                               <{bOnClose}>,                                 ;
                               <{bUpClick}>,                                 ;
                               <{bDnClick}>,                                 ;
                               <{bLfClick}>,                                 ;
                               <{bRtClick}>,                                 ;
                               <.lDbfMgr.>,                                  ;
                               <bReader>,                                    ;
                               <.lMFree.> )

   #command ACTIVATE WINDOW <cNameWnd> [CONTROL <aGetList>]                  ;
                                       [READER <bReader>] [<lkill:KILL>] =>  ;
            WndTask( @<cNameWnd>, nWND_TASK_ACTIVATE, [<aGetList>],          ;
                     <.lkill.>, [<bReader>] )

   #command SHOW WINDOW <cNameWnd>                                     =>    ;
            WndTask( @<cNameWnd>, nWND_TASK_SHOW )

   #command CLOSE WINDOW <cNameWnd>                                    =>    ;
            WndTask( @<cNameWnd>, nWND_TASK_CLOSE )

   #command KILL WINDOW <cNameWnd>                                     =>    ;
            WndTask( @<cNameWnd>, nWND_TASK_KILL )

   #command MOVE WINDOW <cNameWnd>                                     =>    ;
            WndTask( @<cNameWnd>, nWND_TASK_MOVE )

   #command INFO WINDOW <cNameWnd> TO <cVar>                           =>    ;
            <cVar> := WndTask( @<cNameWnd>, nWND_TASK_INFO )

   #command WINDOW <cNameWnd> BARSCROLL VERTICAL   <nAct> OF <nMax>    =>    ;
            WndTask( @<cNameWnd>, nWND_TASK_V_BAR, <nAct>, <nMax> )

   #command WINDOW <cNameWnd> BARSCROLL HORIZONTAL <nAct> OF <nMax>    =>    ;
            WndTask( @<cNameWnd>, nWND_TASK_H_BAR, <nAct>, <nMax> )


   #command @ <nRow>, <nCol> SAY <xExpr> WINDOW <cNameWnd>                   ;
                            [PICTURE <cPict>]                                ;
                            [COLOR <cClr>]                             =>    ;
            WndTask( @<cNameWnd>, nWND_TASK_SAY,;
                     <nRow>, <nCol>, <xExpr>, [<cPict>], [<cClr>] )

#endif
