/*------------------------------------------------------------------------------

   Windows examples:
                     AsciiTable()    --> Simple window
                     WndClrPalete()  --> Window with special reader


   (c) Francisco Morero Peyrona - 1993
       Alfonso Fraguas Bravo    - 1993

------------------------------------------------------------------------------*/

function AsciiTable()

   local GetList := {},;
         nAsc    := 1,;
         acAsc   := Array( 256 ),;
         wndDlg  := WndNew( nMAXROW-15,38, nMAXROW-2,75, "ASCII Table", aClr[ CLR_AVISO ] ),;
         i

   for i = 0 to 255
       acAsc[ i+1 ] = "  " + Chr( i ) + "   (" + Str( i, 3 ) + ")  "
   next

   @ nMAXROW-13,40 GET nAsc LISTBOX acAsc SIZE 11,17    COLOR aClr[ CLR_LIST ]
   @ nMAXROW-12,60 BUTTON "  Paste &Chr  ";
                   EXEC ( i := 1, BTN_OK )              COLOR aClr[ CLR_BUTTON ]
   @ nMAXROW -9,60 BUTTON "  Paste &Num  ";
                   EXEC ( i := 2, BTN_OK )              COLOR aClr[ CLR_BUTTON ]
   @ nMAXROW -6,60 BUTTON "    &Quit     ";
                   EXEC BTN_CANCEL                      COLOR aClr[ CLR_BUTTON ]
   ACTIVATE WINDOW wndDlg CONTROL GetList KILL

   if LastKey() != K_ESC
      KEYBOARD  If( i == 1, Chr( nAsc-1 ), LTrim( Str( nAsc-1 ) ) )
   endif

return NIL

//----------------------------------------------------------------------------//

function SelectClr()

   local nWnd

   @ 0,0,17,25 CREATE WINDOW nWnd TITLE "Color Palette";
               READER { | nHandler | WndClrPalete( nHandler ) }

   ACTIVATE WINDOW nWnd KILL

return NIL

//-------------------------------------//
static func WndClrPalete( nWnd )

   local aColor  := { "N", "B", "G", "BG", "R", "RB", "GR", "W",;
                      "N+","B+","G+","BG+","R+","RB+","GR+","W+",;
                      "N*","B*","G*","BG*","R*","RB*","GR*","W*" }
   local i, h, xEvent, aWndInfo

   for i = 1 to 16
       for h = 1 to 24
           @ i, h SAY "" COLOR aColor[ i ] + "/" + aColor[ h ]
       next
   next

   do while .T.
      xEvent = LeeRtnKey()

      if ValType( xEvent ) == "N"
         if xEvent == K_ESC
            EXIT
         else
            LOOP
         endif
      endif

      if xEvent[ nRTN_B ] == nRTN_BTN_IZQ
         INFO WINDOW nWnd TO aWndInfo

         if xEvent[ nRTN_Y ] > aWndInfo[ nWND_Y1 ] .and. ;    // se est dentro
            xEvent[ nRTN_X ] > aWndInfo[ nWND_X1 ] .and. ;    // del rea de
            xEvent[ nRTN_Y ] < aWndInfo[ nWND_Y2 ] .and. ;    // colores
            xEvent[ nRTN_X ] < aWndInfo[ nWND_X2 ]

            i = xEvent[ nRTN_Y ] - aWndInfo[ nWND_Y1 ]
            h = xEvent[ nRTN_X ] - aWndInfo[ nWND_X1 ]
            KEYBOARD Chr( 0 )
            KEYBOARD ( aColor[ i ] + "/" + aColor[ h ] )
            EXIT
         endif
      endif
   enddo

return NIL

//----------------------------------------------------------------------------//
